# Generated by Django 3.2.5 on 2021-07-27 04:17

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='AlembicVersion',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('version_num', models.TextField()),
            ],
            options={
                'db_table': 'alembic_version',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Field',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'field',
            },
        ),
        migrations.CreateModel(
            name='Method',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'method',
            },
        ),
        migrations.CreateModel(
            name='Person',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('source_id', models.IntegerField(blank=True, null=True)),
                ('title', models.TextField(blank=True, null=True)),
                ('first_name', models.TextField(blank=True, null=True)),
                ('last_name', models.TextField(blank=True, null=True)),
                ('organisation', models.TextField(blank=True, null=True)),
                ('position', models.TextField(blank=True, null=True)),
                ('country', models.TextField(blank=True, null=True)),
                ('contact_email', models.TextField(blank=True, null=True)),
                ('personal_url', models.TextField(blank=True, null=True)),
                ('biography', models.TextField(blank=True, null=True)),
                ('field_indexer', models.TextField(blank=True, db_column='_indexer', null=True)),
            ],
            options={
                'db_table': 'person',
            },
        ),
        migrations.CreateModel(
            name='Range',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('source_id', models.IntegerField(blank=True, null=True)),
                ('gmba_id', models.TextField(blank=True, null=True)),
                ('name', models.TextField(blank=True, null=True)),
                ('countries', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'range',
            },
        ),
        migrations.CreateModel(
            name='Resource',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('source_id', models.IntegerField(blank=True, null=True)),
                ('title', models.TextField(blank=True, null=True)),
                ('url', models.TextField(blank=True, null=True)),
                ('citation', models.TextField(blank=True, null=True)),
                ('abstract', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'resource',
            },
        ),
        migrations.CreateModel(
            name='Scale',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'scale',
            },
        ),
        migrations.CreateModel(
            name='Taxon',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'taxon',
            },
        ),
        migrations.CreateModel(
            name='TaxaPeople',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.person')),
                ('taxon', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.taxon')),
            ],
            options={
                'db_table': 'taxa_people',
            },
        ),
        migrations.CreateModel(
            name='ScalesPeople',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.person')),
                ('scale', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.scale')),
            ],
            options={
                'db_table': 'scales_people',
            },
        ),
        migrations.CreateModel(
            name='ResourcesPeople',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.person')),
                ('resource', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.resource')),
            ],
            options={
                'db_table': 'resources_people',
            },
        ),
        migrations.CreateModel(
            name='RangesPeople',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.person')),
                ('range', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.range')),
            ],
            options={
                'db_table': 'ranges_people',
            },
        ),
        migrations.CreateModel(
            name='MethodsPeople',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('method', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.method')),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.person')),
            ],
            options={
                'db_table': 'methods_people',
            },
        ),
        migrations.CreateModel(
            name='FieldsPeople',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.field')),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='app.person')),
            ],
            options={
                'db_table': 'fields_people',
            },
        ),
    ]
